image:
  name: hashicorp/terraform:light
  entrypoint:
    - '/usr/bin/env'
    - 'PATH=/usr/local/sbin:/usr/local/bin:/usr/sbin:/usr/bin:/sbin:/bin'
before_script:
  - rm -rf .terraform
  - terraform --version
  - mkdir -p ./creds
  - echo $SERVICEACCOUNT | base64 -d > ./creds/serviceaccount.json
  - terraform init
############################################################
#Create the user data here and parametrize the runner token#
############################################################
  - | 
    cat <<EOF > variables.tf
        variable "aws_access_keys" {
        type = map(string)
        description = "AWS Access Keys for terraform deployment"

        default = {
            access_key = "$AWS_ACCESS_KEY_ID"
            secret_key = "$AWS_SECRET_ACCESS_KEY"
            region = "us-east-1"
        }
        }

        variable "subnets" {
        type = "map"
        description = "Available subnets in this deployment"

        default = {
            subnet01 = "subnet-9fc109d7"
            subnet02 = "subnet-957609a9"
        }
        }

        variable "ami_id" {
        type = "string"
        description = "Ubuntu AMI"
        default = "ami-0ac80df6eff0e70b5"
        }

        variable "instance_type" {
        type = "string"
        description = "The instance type of the node"
        default = "t2.micro"
        }

        variable "key_name" {
        type = "string"
        description = "Keypair name"
        default = "opsbox19"
        }

        variable "user_data_file" {
        type = "string"
        description = "User data to install rancher in HA"
        default = "scripts/user_data.tpl"
        }

    EOF

#create-runner:
#  stage: run
#  script:
#    - terraform init 
#    - terraform plan
#    - terraform apply
#  tags:
#    - run

stages:
  - validate
  - plan
  - apply

validate:
  stage: validate
  script:
    - terraform validate

plan:
  stage: plan
  script:
    - terraform plan -out "planfile"
  dependencies:
    - validate
  artifacts:
    paths:
      - planfile

apply:
  stage: apply
  script:
    - terraform apply -input=false "planfile"
  dependencies:
    - plan
  when: manual
